<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>HW(JS15)</title>
    <link rel="stylesheet" href="css/slyle.css">
</head>
<body>
   <div class='wrapper'>

       <label for="min">
         <input id="min" type="text">
         <span>min</span>        
       </label>
     
       <label for="sec">
         <input id="sec" type="text">
         <span>sec</span>        
       </label>
     
       <label for="ms">
         <input id="ms" type="text">
         <span>ms</span>        
       </label>
       <button id="buttonStartPause" class="start">Start</button>
       <button id="clear">Clear</button>

   </div>
   
    <script>
        let timer = {};
        
        timer.time = 0;
        timer.check = false;
        
        
        timer.startTimer = function (){
            let startTime = new Date();//записали время старта функции
            timer.check = true;
            document.getElementById('buttonStartPause').removeEventListener( 'click', timer.startTimer);
            document.getElementById('buttonStartPause').textContent = 'Pause';
            document.getElementById('buttonStartPause').addEventListener( 'click', timer.pauseTimer );
            
            
            let timerId = setInterval(function(){
                  let currentTime = new Date(),
                      deltaTime = new Date( +currentTime - +startTime + +timer.time );
              if(timer.check){
                  document.getElementById('min').value = deltaTime.getMinutes();
                  document.getElementById('sec').value = deltaTime.getSeconds();
                  document.getElementById('ms').value = deltaTime.getMilliseconds();
              } else {
                timer.time = deltaTime;
                clearInterval(timerId);
                console.log(timer.time);
                return;  
                }
            
              }, 50);
        };
        
        
        timer.pauseTimer = function (){
          timer.check = false;
          document.getElementById('buttonStartPause').removeEventListener( 'click', timer.pauseTimer );
          document.getElementById('buttonStartPause').textContent = 'Start';
          document.getElementById('buttonStartPause').addEventListener( 'click', timer.startTimer );
        };
        
        timer.clearTimer = function(){
          document.getElementById('clear').removeEventListener( 'click', timer.clearTimer );
          document.getElementById('clear').addEventListener( 'click', timer.clearTimer );
          
            
          timer.time = 0;
          document.getElementById('min').value = 0;
          document.getElementById('sec').value = 0;
          document.getElementById('ms').value = 0;
          
          timer.check = false;
          document.getElementById('buttonStartPause').removeEventListener( 'click', timer.startTimer); 
          document.getElementById('buttonStartPause').textContent = 'Start';
          document.getElementById('buttonStartPause').addEventListener( 'click', timer.startTimer );
        };
        
    
          document.getElementById('buttonStartPause').addEventListener( 'click', timer.startTimer);    
          document.getElementById('clear').addEventListener( 'click', timer.clearTimer );  
        
        
    
    </script> 
</body>
</html>